from Def3d import *

palette={"red":Color3f(1,0,0),
	"green":Color3f(0,1,0),
	"blue":Color3f(0,0,1),
	"teal":Color3f(0,0.5,1),
	"cyan":Color3f(0,1,1),
	"lilac":Color3f(0.5,0.5,1),
	"magenta":Color3f(1,0,1),
	"yellow":Color3f(1,1,0),
	"orange":Color3f(0.5,1,0),
	"darkgray":Color3f(0.2,0.2,0.2),
	"gray":Color3f(0.5,0.5,0.5),
	"brown":Color3f(0.7,0.8,0.3),
	"beige":Color3f(1,1,0.6),
	"white":Color3f(1,1,1),
	"black":Color3f(0,0,0)
	}

def plastic(s):
        ap=Appearance()
	ap.setMaterial(Material( palette["black"], palette["black"],
	                         palette[s],  palette["white"], 64 ))
	return ap

def rubber(s):
        ap=Appearance()
	ap.setMaterial(Material( palette["black"], palette["black"],
	                         palette[s],  palette["darkgray"], 1 ))
	return ap

def emissive(s):
        ap=Appearance()
	ap.setMaterial(Material( palette["black"], palette[s],
	                         palette["black"],  palette["white"], 1 ))
	return ap

def wireframe(s):
	ap=Appearance()
	ap.setPolygonAttributes(
		PolygonAttributes(PolygonAttributes.POLYGON_LINE,
			PolygonAttributes.CULL_NONE,0))
	ap.setColoringAttributes(
		ColoringAttributes(palette[s],ColoringAttributes.SHADE_FLAT))
	return ap


def copper():
        ap=Appearance()
	ap.setMaterial(Material( Color3f(0, 0.1, 0), Color3f(0, 0, 0),
	                         Color3f(0.7, 0, 0 ),  Color3f(1, 1, 1), 4 ))
	ca=ColoringAttributes()
	ca.setShadeModel(ColoringAttributes.SHADE_GOURAUD)
	ap.setColoringAttributes(ca)
	return ap

		
def rubber_red():
        ap=Appearance()
	ap.setMaterial(Material( Color3f(0.2, 0, 0), Color3f(0, 0, 0),
	                         Color3f(0.6, 0, 0 ),  Color3f(0.2, 0.2, 0.2), 1 ))
	return ap

def plastic_red():
        ap=Appearance()
	ap.setMaterial(Material( Color3f(0.1, 0, 0), Color3f(0, 0, 0),
	                         Color3f(0.6, 0, 0 ),  Color3f(1,1,1), 64 ))
	return ap

def wireframe_red():
	ap=Appearance()
	ap.setPolygonAttributes(
		PolygonAttributes(PolygonAttributes.POLYGON_LINE,
			PolygonAttributes.CULL_NONE,0))
	ap.setColoringAttributes(
		ColoringAttributes(1,0,0,ColoringAttributes.SHADE_FLAT))
	return ap
	

