from Def3d import *
from Materials import *
from Helix import *
from Cyl import *

def scenegraph():
	objroot=BranchGroup()
	
	p1=Point3f(0,-0.7,0)
	p2=Point3f(0,0.7,0)
	
	
	objroot.addChild( helix( p1, p2,
		0.1, 0.25, steps=1, ap=plastic("yellow")))
	objroot.addChild( helix( p1, p2,
		0.1, 0.25, steps=1, ap=plastic("blue"),phase=Math.PI/4.0))

		
	h=p1.distance(p2)

	cylset=BranchGroup()
	cyls=10
	r2=0.25
	phase=Math.PI/4.0
	for j in range(cyls):
		s=j*1.0/cyls
		ss=(j+1.0)/cyls
		x0=r2*Math.cos(2*Math.PI*s)
		y0=h*(s)
		z0=r2*Math.sin(2*Math.PI*s)
		x1=r2*Math.cos(2*Math.PI*(s+phase))
		y1=h*(s)
		z1=r2*Math.sin(2*Math.PI*(s+phase))
		cylset.addChild(
			cyl(Point3f(x0,y0,z0),Point3f(x1,y1,z1),0.01,
				ap=emissive("red")))

	m3f=rotation_y_vector(p1, p2)
	t3d=Transform3D(Matrix3f(m3f),Vector3f(p1),1.0)
	
	rott=Transform3D()
	rott.rotY(0*Math.PI/16)
	
	t3d.mul(t3d,rott)
	
	tg=TransformGroup(t3d)
	tg.addChild(cylset)
	objroot.addChild(tg)
		
	return objroot


mf=MainFrame(Orbiting(scenegraph),640,480)

